/* =======================================
   Maxim-IC 7219
   8fach 7-Segment Treiber IC (SPI)

   Stefan Mnch
   http://www.stefan-moench.de
   stefan@moench.de
======================================= */

#include "main.h"
#include "max7219.h"

void segWrite (unsigned char data_out){
	unsigned char loop, mask;
	for (loop=0,mask=0x80;loop<8;loop++, mask=mask>>1)
  {
  	PORT_SCK_7219 &= ~(1<<PIN_SCK_7219);
	  if (data_out & mask)
  	  PORT_MOSI_7219 |= (1<<PIN_MOSI_7219);
	  else
  	  PORT_MOSI_7219 &= ~(1<<PIN_MOSI_7219);
	  PORT_SCK_7219 |= (1<<PIN_SCK_7219);
	}
	PORT_SCK_7219 &= ~(1<<PIN_SCK_7219);
}

void segAusgabe (unsigned char address, unsigned char data) {
  PORT_CS_7219 |= (1<<PIN_CS_7219);    // Chip Select
  segWrite(address);
  segWrite(data);
  PORT_CS_7219 &= ~(1<<PIN_CS_7219);   // Chip Unselect
}

void segInit (void) {
	unsigned char loop;

  DDR_SCK_7219 |= (1<<PIN_SCK_7219);
  DDR_MOSI_7219 |= (1<<PIN_MOSI_7219);
  DDR_CS_7219 |= (1<<PIN_CS_7219);

	for (loop = 0; loop < 4; loop++) {  // 4 mal um Fehler zu eliminieren
  	segAusgabe(0x0c, 0x01);  // Shutdown aus
	  segAusgabe(0x09, 0xff);  // Decode-Mode: alles auf Code B
  	segAusgabe(0x0a, 0x08);  // Intensitt
	  segAusgabe(0x0b, 0x05);  // 6 digits
  }

  for (loop = 1; loop <= 6; loop++)
    segAusgabe(loop, 0x0A);   // "-" auf allen Anzeigen anzeigen
}